Merge branch 'master' into msp430
[llvm/msp430.git] / utils / buildit / build_llvm
blobeac68b4f572fa73879c3a4e8ac0a9b27eb4ac2cb
1 #!/bin/sh
2 # LLVM LOCAL file B&I
4 set -x
6 # Build LLVM the "Apple way".
7 # Parameters:
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 # FIXME: HOSTS is not used in this script. Use it or Remove it.
13 HOSTS="$1"
15 # The second parameter is a space-separated list of the architectures the
16 # compilers will generate code for. If the current machine isn't in the list, a
17 # compiler for it will get built anyway, but won't be installed.
18 TARGETS="$2"
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
45 # The nineth parameter is the version number of the submission, e.g. 1007.
46 LLVM_SUBMIT_VERSION="$9"
48 # The tenth parameter is the subversion number of the submission, e.g. 03.
49 LLVM_SUBMIT_SUBVERSION="${10}"
51 # The current working directory is where the build will happen. It may already
52 # contain a partial result of an interrupted build, in which case this script
53 # will continue where it left off.
54 DIR=`pwd`
56 DARWIN_VERS=`uname -r | sed 's/\..*//'`
57 echo DARWIN_VERS = $DARWIN_VERS
59 # If the user has CC set in their environment unset it now
60 unset CC
62 DT_HOME=$DEST_DIR/Developer/usr
63 DEST_ROOT="/Developer$DEST_ROOT"
64 if [ "x$DEVELOPER_BIN" != "x" ]; then
65 DT_HOME=$DEST_DIR/$DEVELOPER_DIR/usr
66 DEST_ROOT="/$DEVELOPER_DIR$DEST_ROOT"
69 ################################################################################
70 # Run the build.
72 # Create the source tree we'll actually use to build, deleting
73 # tcl since it doesn't actually build properly in a cross environment
74 # and we don't really need it.
75 SRC_DIR=$DIR/src
76 rm -rf $SRC_DIR || exit 1
77 mkdir $SRC_DIR || exit 1
78 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
80 # Build the LLVM tree universal.
81 mkdir -p $DIR/obj-llvm || exit 1
82 cd $DIR/obj-llvm || exit 1
84 if [ \! -f Makefile.config ]; then
85 $SRC_DIR/configure --prefix=$DT_HOME/local \
86 --enable-targets=arm,x86,powerpc,cbe \
87 --enable-assertions=$LLVM_ASSERTIONS \
88 --enable-optimized=$LLVM_OPTIMIZED \
89 || exit 1
92 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
94 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
95 LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
96 RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
97 LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
100 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
101 LLVM_VERSION="$LLVM_SUBMIT_VERSION"
102 else
103 LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
106 GCC_VER=`cc --version 2>/dev/null | sed 1q`
108 if echo "$GCC_VER" | grep GCC > /dev/null; then
109 GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
110 MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
111 MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
114 JOBS_FLAG=""
116 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
117 # already has parallelism and we don't want to make the builders hit swap by
118 # firing off too many gccs at the same time.
119 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
120 # Figure out how many make processes to run.
121 SYSCTL=`sysctl -n hw.activecpu`
123 # hw.activecpu only available in 10.2.6 and later
124 if [ -z "$SYSCTL" ]; then
125 SYSCTL=`sysctl -n hw.ncpu`
128 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
129 # Builders can default to 2, since even if they are single processor,
130 # nothing else is running on the machine.
131 if [ -z "$SYSCTL" ]; then
132 SYSCTL=2
135 JOBS_FLAG="-j $SYSCTL"
138 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$TARGETS" \
139 LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
140 LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
141 CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
142 VERBOSE=1
144 if ! test $? == 0 ; then
145 echo "error: LLVM 'make' failed!"
146 exit 1
149 ################################################################################
150 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
151 # $DEST_DIR, with occasional 'lipo' commands.
153 cd $DEST_DIR || exit 1
155 # Clean out DEST_DIR in case -noclean was passed to buildit.
156 rm -rf * || exit 1
158 cd $DIR/obj-llvm || exit 1
160 # Install the tree into the destination directory.
161 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$TARGETS" \
162 LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
163 LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
164 OPTIMIZE_OPTION='-O3' VERBOSE=1 install
166 if ! test $? == 0 ; then
167 echo "error: LLVM 'make install' failed!"
168 exit 1
171 # Install Version.h
172 RC_ProjectSourceSubversion=`printf "%d" $LLVM_SUBMIT_SUBVERSION`
173 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
174 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
176 if [ "x$LLVM_DEBUG" != "x1" ]; then
177 # Strip local symbols from llvm libraries.
178 strip -S $DEST_DIR$DEST_ROOT/lib/*.[oa]
179 for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
180 strip -Sx $f
181 done
184 # Copy over the tblgen utility.
185 cp `find $DIR -name tblgen` $DT_HOME/local/bin
187 # Remove .dir files
188 cd $DEST_DIR$DEST_ROOT
189 rm -f bin/.dir etc/llvm/.dir lib/.dir
191 # Remove PPC64 fat slices.
192 cd $DEST_DIR$DEST_ROOT/bin
193 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
194 find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
195 -exec lipo -extract ppc -extract i386 {} -output {} \;
196 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
197 find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
198 -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
199 else
200 find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
201 -exec lipo -extract ppc7400 -extract i386 -extract x86_64 {} -output {} \;
204 cd $DEST_DIR$DEST_ROOT
205 mkdir -p $DT_HOME/lib
206 mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
207 strip -S $DT_HOME/lib/libLTO.dylib
208 rm -f lib/libLTO.a lib/libLTO.la
210 # The Hello dylib is an example of how to build a pass. No need to install it.
211 rm lib/libLLVMHello.dylib
213 # Compress manpages
214 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
215 gzip -f $MDIR/*
217 ################################################################################
218 # Create SYM_DIR with information required for debugging.
220 # Figure out how many make processes to run.
221 SYSCTL=`sysctl -n hw.activecpu`
223 # hw.activecpu only available in 10.2.6 and later
224 if [ -z "$SYSCTL" ]; then
225 SYSCTL=`sysctl -n hw.ncpu`
228 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
229 # can default to 2, since even if they are single processor, nothing else is
230 # running on the machine.
231 if [ -z "$SYSCTL" ]; then
232 SYSCTL=2
235 cd $SYM_DIR || exit 1
237 # Clean out SYM_DIR in case -noclean was passed to buildit.
238 rm -rf * || exit 1
240 # Generate .dSYM files
241 find $DEST_DIR -perm -0111 -type f \
242 ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
243 -print | xargs -n 1 -P ${SYSCTL} dsymutil
245 # Save .dSYM files and .a archives
246 cd $DEST_DIR || exit 1
247 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
248 | cpio -pdml $SYM_DIR || exit 1
250 # Save source files.
251 mkdir $SYM_DIR/src || exit 1
252 cd $DIR || exit 1
253 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
254 | cpio -pdml $SYM_DIR/src || exit 1
256 ################################################################################
257 # Remove debugging information from DEST_DIR.
259 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
260 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
261 chgrp -h -R wheel $DEST_DIR
262 chgrp -R wheel $DEST_DIR
264 ################################################################################
265 # Remove tar ball from docs directory
267 find $DEST_DIR -name html.tar.gz -exec rm {} \;
269 ################################################################################
270 # w00t! Done!
272 exit 0